{Ŀ}
{ MODULE:         DevFile                                                  }
{                                                                          }
{ DESCRIPTION:    Device driver for the Adlib sound card and compatibles.  }
{                 This works with Sound Blasters and with Covox SM II.     }
{                 It uses timer polling.                                   }
{                                                                          }
{ DEVELOPER:      Carlos daSilva                                           }
{}
UNIT DevFile;

INTERFACE
{Ŀ}
{ Device ID string                                                         }
{}

CONST FileDevID    = 'File';
      FileDevFName : String = 'SBDSP$';

FUNCTION FileRun : Char;

IMPLEMENTATION
USES Dos, Kbd, SoundDevices, StrConst;

VAR Fil : File;

FUNCTION DosDevIOCTL(VAR F; Cat, Func : Byte; VAR Data) : Word; ASSEMBLER;
ASM
  PUSH    DS

  MOV     CH,[Cat]
  MOV     CL,[Func]
  LDS     BX,[f]
  MOV     BX,FileRec([DS:BX]).Handle
  LDS     DX,Data
  MOV     AX,$440C
  INT     $21

  POP     DS

  JC      @@Fin
  XOR     AX,AX
@@Fin:
END;

VAR Null : Byte ABSOLUTE 0:0;

VAR FileBuffer : ARRAY[1..1600] of Byte;
    FileDevIdx : Word;

    TimerPos   : Byte ABSOLUTE 0:$46C;

CONST LastTimerPos : Byte = 0;

FUNCTION FilePoll : Boolean; FAR;
TYPE WB = ARRAY[1..32760] of Word;
CONST Delay : Word = 0;
      Ct    : Word = 0;
VAR MBuffer  : ^WB ABSOLUTE Sounding;
    I, J     : Word;
    R        : Word;
    Lim      : Word;
BEGIN
  FilePoll := True;

  If TimerPos = LastTimerPos then Exit;

  LastTimerPos := TimerPos;

  Inc(Ct, 500);
  Lim := Ct div 180;
  Ct  := Ct mod 180;

  For J := 1 to Lim do
  BEGIN
    If DoGetBuffer <> 0 then
    BEGIN
      If FileDevIdx + SoundLeft > 1600 then
      BEGIN
{
        DosDevIOCtl(Fil, $80, 3, NULL);
        DosDevIOCtl(Fil, $80, 0, NULL);
}
        BlockWrite(Fil, FileBuffer[1], FileDevIdx, R);
        FileDevIdx := 0;
      END;

      ASM
        MOV    CX,SoundLeft
        LES    SI,MBuffer
        MOV    DI,OFFSET FileBuffer
        MOV    AX,FileDevIdx
        ADD    DI,AX

      @@lp:
        MOV    AX,[ES:SI]
        ADD    AX,[ES:SI+6]
        ADD    AX,[ES:SI+8]
        ADD    AX,[ES:SI+14]
        ADD    AX,[ES:SI+16]
        ADD    AX,[ES:SI+22]
        ADD    AX,[ES:SI+24]
        ADD    AX,[ES:SI+30]

        MOV    BX,[ES:SI+2]
        ADD    BX,[ES:SI+4]
        ADD    BX,[ES:SI+10]
        ADD    BX,[ES:SI+12]
        ADD    BX,[ES:SI+18]
        ADD    BX,[ES:SI+20]
        ADD    BX,[ES:SI+26]
        ADD    BX,[ES:SI+28]

        ADD    AX,BX
        JNO    @@nooverf
        JS     @@posit
        MOV    AX,-32768
        JMP    @@nooverf

      @@posit:
        MOV    AX,32767

      @@nooverf:
        XOR    AH,80h
        MOV    [DI],AH
        INC    DI
        ADD    SI,MaxChannels*2
        LOOP   @@lp
      END;

{
      For I := 1 to SoundLeft do
      BEGIN
        FileBuffer[FileDevIdx + I] := Hi(MBuffer^[I*4] +
                                         MBuffer^[I*4-1] +
                                         MBuffer^[I*4-2] +
                                         MBuffer^[I*4-3]) xor 128;
      END;
}
      Inc(FileDevIdx, SoundLeft);
      Delay := 0;
    END else Inc(Delay);

    PeriodicProc;
    If Delay > 3 then
    BEGIN
      If FileDevIdx > 0 then
      BEGIN
        BlockWrite(Fil, FileBuffer[1], FileDevIdx, r);
      END;
      FilePoll := False;
      Exit;
    END;
  END;

  FilePoll := True;
END;

PROCEDURE DevFilePoll; FAR;
BEGIN
  FilePoll;
END;

FUNCTION FileRun : Char;
VAR Ch : Char;
BEGIN
  FileRun := #0;

  WHILE NOT KbdKeyPressed and FilePoll DO
    Dec(LastTimerPos);

  WHILE KbdKeyPressed DO
  BEGIN
    Ch := Char(KbdReadKey);
    FileRun := Ch;
  END;

  DeviceIdling := True;
END;

{Ŀ}
{ Name function                                                            }
{}
FUNCTION FileName : tDevName; FAR;
BEGIN
  FileName := GetString(StrDevFileName);
END;

{Ŀ}
{ Autodetect routine                                                       }
{}
FUNCTION DevDetect : Boolean; FAR;
BEGIN
  DevDetect := True;
END;

{Ŀ}
{ Device initialization routine                                            }
{}
PROCEDURE DevInit(Hz : Word); FAR;
VAR W : Word;
BEGIN
  Assign(Fil, FileDevFName);
  Rewrite(Fil, 1);

  W := 0;

  DosDevIOCtl(Fil, $80, 1, Hz);
  DosDevIOCtl(Fil, $80, 5, w);

  CalcTimerData(Hz);   { Init variables. Shouldn't do it this way, but... }
  FileDevIdx   := 0;
  DeviceIdling := False;
END;

{Ŀ}
{ Device deinitialization routines                                         }
{}
PROCEDURE DevEnd; FAR;
BEGIN
{
    DosDevIOCtl(Fil, $80, 0, NULL);
}
  Close(Fil);
END;

{Ŀ}
{ Accessory routines                                                       }
{}
PROCEDURE DevChgHz(Hz : Word); FAR;
BEGIN
  CalcTimerData(Hz);
  DosDevIOCtl(Fil, $80, 0, NULL);
  Close(Fil);
  Rewrite(Fil, 1);
  DosDevIOCtl(Fil, $80, 1, Hz);
END;

{Ŀ}
{ Device record                                                            }
{}
CONST FileData : tSoundDevice =
      (DevID : FileDevID;
       DMA   : False);

{Ŀ}
{ Initialization code                                                      }
{}
BEGIN
  WITH FileData DO
  BEGIN
    Name            := FileName;
    AutoDetect      := DevDetect;
    InitRut         := DevInit;
    ChgHzProc       := DevChgHz;
    GetRealFreqProc := GetRealFreq;
    PollRut         := DevFilePoll;
    EndRut          := DevEnd;
  END;

  InitDevice(@FileData);
END.
