{Ŀ}
{ MODULE:         DevSBDac                                                 }
{                                                                          }
{ DESCRIPTION:    Device driver for the joined <SoundBlaster & Dac>        }
{                 stereo.  It uses timer polling.                          }
{                                                                          }
{ DEVELOPER:      Carlos daSilva                                           }
{}
UNIT DevSBDAC;

INTERFACE

{Ŀ}
{ Device ID string                                                         }
{}
CONST SbDACDevID      = 'DAC-SB';
      MixSbDACDevID   = 'Mix-DAC-SB';
      Mix2SbDACDevID  = 'Mix2-DAC-SB';

IMPLEMENTATION
USES SoundDevices, StrConst, DevSB, DevDAC, SoundBlaster;

{Ŀ}
{ Assembler IRQs                                                           }
{}
{$L DEVSBDAC}

PROCEDURE SbDACIntHandler;     FAR; EXTERNAL;
PROCEDURE MixSbDACIntHandler;  FAR; EXTERNAL;
PROCEDURE Mix2SbDACIntHandler; FAR; EXTERNAL;

{Ŀ}
{ Name functions                                                           }
{}
FUNCTION SBDacName : tDevName; FAR;
BEGIN
  SBDacName     := GetString(StrDevSBDacName);
END;

FUNCTION MixSBDacName : tDevName; FAR;
BEGIN
  MixSBDacName  := GetString(StrDevMixSBDacName);
END;

FUNCTION Mix2SBDacName : tDevName; FAR;
BEGIN
  Mix2SBDacName := GetString(StrDevMix2SBDacName);
END;

{Ŀ}
{ Autodetect function                                                      }
{}
FUNCTION SbDACDetect : Boolean; FAR;
BEGIN
  SBDACDetect := SBRegDetect;
END;

{Ŀ}
{ Device initialization routine                                            }
{}
PROCEDURE DevInit(Hz : Word); FAR;
BEGIN
  SBInit(Hz);
END;

{Ŀ}
{ Device deinitialization routine                                          }
{}
PROCEDURE DevEnd; FAR;
BEGIN
  SbEnd;
END;

{Ŀ}
{ Accessory routines                                                       }
{}
PROCEDURE DevChgHz(Hz : Word); FAR;
BEGIN
  CalcTimerData(Hz);
  InitTimer;
END;

PROCEDURE DevPoll; FAR;
BEGIN
END;

{Ŀ}
{ Device records                                                           }
{}
CONST SbDACData : tSoundDevice =
      (DevID : SbDACDevID;
       DMA   : False);

CONST MixSbDACData : tSoundDevice =
      (DevID : MixSbDACDevID;
       DMA   : False);

CONST Mix2SbDACData : tSoundDevice =
      (DevID : Mix2SbDACDevID;
       DMA   : False);

{Ŀ}
{ Initialization code                                                      }
{}
BEGIN
  WITH SbDACData DO
  BEGIN
    Name            := SbDACName;
    AutoDetect      := SbDACDetect;
    InitRut         := DevInit;
    ChgHzProc       := DevChgHz;
    GetRealFreqProc := GetRealFreq;
    TimerHandler    := SbDACIntHandler;
    PollRut         := DevPoll;
    EndRut          := DevEnd;
  END;

  WITH MixSbDACData DO
  BEGIN
    Name            := MixSbDACName;
    AutoDetect      := SbDACDetect;
    InitRut         := DevInit;
    ChgHzProc       := DevChgHz;
    GetRealFreqProc := GetRealFreq;
    TimerHandler    := MixSbDACIntHandler;
    PollRut         := DevPoll;
    EndRut          := DevEnd;
  END;

  WITH Mix2SbDACData DO
  BEGIN
    Name            := Mix2SbDACName;
    AutoDetect      := SbDACDetect;
    InitRut         := DevInit;
    ChgHzProc       := DevChgHz;
    GetRealFreqProc := GetRealFreq;
    TimerHandler    := Mix2SbDACIntHandler;
    PollRut         := DevPoll;
    EndRut          := DevEnd;
  END;

  InitDevice(@Mix2SbDACData);
  InitDevice(@MixSbDACData);
  InitDevice(@SbDACData);
END.
